diff --git a/src/main/java/net/minecraft/client/option/GameSettings.java b/src/main/java/net/minecraft/client/option/GameSettings.java
index b059de517..a2cdfad31 100644
--- a/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -15,6 +15,7 @@ import com.b100.utils.ReflectUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.discord.RichPresenceHandlerThread;
 import net.minecraft.client.gui.hud.HudComponents;
+import net.minecraft.client.input.InputDevice;
 import net.minecraft.client.option.enums.Colorblindness;
 import net.minecraft.client.option.enums.Difficulty;
 import net.minecraft.client.option.enums.LightmapStyle;
@@ -31,7 +32,6 @@ import net.minecraft.core.util.helper.ITranslatable;
 
 public class GameSettings {
 
-	private static final String[] LIMIT_FRAMERATES = { "performance.max", "performance.balanced", "performance.powersaver", "performance.vsync" };
 	private static final String[] ANIMATIONS = { "options.animations.off", "options.animations.procedural", "options.animations.custom" };
 
 	public final Minecraft mc;
@@ -165,57 +165,58 @@ public class GameSettings {
 	public BooleanOption mobVariants = new BooleanOption(this, "mobVariants", true);
 	public EnumOption<Colorblindness> colorblindnessFix = new EnumOption<>(this, "colorblindnessFix", Colorblindness.class, Colorblindness.NONE);
 
-	public KeyBinding keyAttack = new KeyBinding("key.attack").bindMouse(0);
-	public KeyBinding keyInteract = new KeyBinding("key.interact").bindMouse(1);
-	public KeyBinding keyPickBlock = new KeyBinding("key.pickBlock").bindMouse(2);
-	public KeyBinding keySortInventory = new KeyBinding("key.sortInventory").bindMouse(2);
-	public KeyBinding keyForward = new KeyBinding("key.forward").bindKeyboard(KEY_W);
-	public KeyBinding keyLeft = new KeyBinding("key.left").bindKeyboard(KEY_A);
-	public KeyBinding keyBack = new KeyBinding("key.back").bindKeyboard(KEY_S);
-	public KeyBinding keyRight = new KeyBinding("key.right").bindKeyboard(KEY_D);
-	public KeyBinding keyJump = new KeyBinding("key.jump").bindKeyboard(KEY_SPACE);
-	public KeyBinding keyInventory = new KeyBinding("key.inventory").bindKeyboard(KEY_E);
-	public KeyBinding keyDrop = new KeyBinding("key.drop").bindKeyboard(KEY_Q);
-	public KeyBinding keyChat = new KeyBinding("key.chat").bindKeyboard(KEY_T);
-	public KeyBinding keyCommand = new KeyBinding("key.command").bindKeyboard(KEY_SLASH);
-	public KeyBinding keyToggleFog = new KeyBinding("key.fog").bindKeyboard(KEY_F);
-	public KeyBinding keyToggleGamma = new KeyBinding("key.gamma").bindKeyboard(KEY_G);
-	public KeyBinding keySneak = new KeyBinding("key.sneak").bindKeyboard(KEY_LSHIFT);
-	public KeyBinding keyFly = new KeyBinding("key.fly").bindKeyboard(KEY_LCONTROL);
-	public KeyBinding keyGuidebook = new KeyBinding("key.guidebook").bindKeyboard(KEY_R);
-	public KeyBinding keyShowRecipe = new KeyBinding("key.showRecipe").bindKeyboard(KEY_R);
-	public KeyBinding keyShowUsage = new KeyBinding("key.showUsage").bindKeyboard(KEY_U);
-	public KeyBinding keyHotBarLeft = new KeyBinding("key.hotbar.left").bindKeyboard(KEY_COMMA);
-	public KeyBinding keyHotBarRight = new KeyBinding("key.hotbar.right").bindKeyboard(KEY_PERIOD);
-	public KeyBinding keyHotBarSwitch = new KeyBinding("key.hotbar.switch").bindKeyboard(KEY_TAB);
+	public KeyBinding keyAttack = new KeyBinding("key.attack").setDefault(InputDevice.mouse, 0);
+	public KeyBinding keyInteract = new KeyBinding("key.interact").setDefault(InputDevice.mouse, 1);
+	public KeyBinding keyPickBlock = new KeyBinding("key.pickBlock").setDefault(InputDevice.mouse, 2);
+	public KeyBinding keySortInventory = new KeyBinding("key.sortInventory").setDefault(InputDevice.mouse, 2);
+	public KeyBinding keyForward = new KeyBinding("key.forward").setDefault(InputDevice.keyboard, KEY_W);
+	public KeyBinding keyLeft = new KeyBinding("key.left").setDefault(InputDevice.keyboard, KEY_A);
+	public KeyBinding keyBack = new KeyBinding("key.back").setDefault(InputDevice.keyboard, KEY_S);
+	public KeyBinding keyRight = new KeyBinding("key.right").setDefault(InputDevice.keyboard, KEY_D);
+	public KeyBinding keyJump = new KeyBinding("key.jump").setDefault(InputDevice.keyboard, KEY_SPACE);
+	public KeyBinding keyInventory = new KeyBinding("key.inventory").setDefault(InputDevice.keyboard, KEY_E);
+	public KeyBinding keyDrop = new KeyBinding("key.drop").setDefault(InputDevice.keyboard, KEY_Q);
+	public KeyBinding keyChat = new KeyBinding("key.chat").setDefault(InputDevice.keyboard, KEY_T);
+	public KeyBinding keyCommand = new KeyBinding("key.command").setDefault(InputDevice.keyboard, KEY_SLASH);
+	public KeyBinding keyToggleFog = new KeyBinding("key.fog").setDefault(InputDevice.keyboard, KEY_F);
+	public KeyBinding keyToggleGamma = new KeyBinding("key.gamma").setDefault(InputDevice.keyboard, KEY_G);
+	public KeyBinding keySneak = new KeyBinding("key.sneak").setDefault(InputDevice.keyboard, KEY_LSHIFT);
+	public KeyBinding keyFly = new KeyBinding("key.fly").setDefault(InputDevice.keyboard, KEY_LCONTROL);
+	public KeyBinding keyGuidebook = new KeyBinding("key.guidebook").setDefault(InputDevice.keyboard, KEY_R);
+	public KeyBinding keyShowRecipe = new KeyBinding("key.showRecipe").setDefault(InputDevice.keyboard, KEY_R);
+	public KeyBinding keyShowUsage = new KeyBinding("key.showUsage").setDefault(InputDevice.keyboard, KEY_U);
+	public KeyBinding keyHotBarLeft = new KeyBinding("key.hotbar.left").setDefault(InputDevice.keyboard, KEY_COMMA);
+	public KeyBinding keyHotBarRight = new KeyBinding("key.hotbar.right").setDefault(InputDevice.keyboard, KEY_PERIOD);
+	public KeyBinding keyHotBarSwitch = new KeyBinding("key.hotbar.switch").setDefault(InputDevice.keyboard, KEY_TAB);
 
-	public KeyBinding keyHotBarSlot1 = new KeyBinding("key.hotbar.1").bindKeyboard(KEY_1);
-	public KeyBinding keyHotBarSlot2 = new KeyBinding("key.hotbar.2").bindKeyboard(KEY_2);
-	public KeyBinding keyHotBarSlot3 = new KeyBinding("key.hotbar.3").bindKeyboard(KEY_3);
-	public KeyBinding keyHotBarSlot4 = new KeyBinding("key.hotbar.4").bindKeyboard(KEY_4);
-	public KeyBinding keyHotBarSlot5 = new KeyBinding("key.hotbar.5").bindKeyboard(KEY_5);
-	public KeyBinding keyHotBarSlot6 = new KeyBinding("key.hotbar.6").bindKeyboard(KEY_6);
-	public KeyBinding keyHotBarSlot7 = new KeyBinding("key.hotbar.7").bindKeyboard(KEY_7);
-	public KeyBinding keyHotBarSlot8 = new KeyBinding("key.hotbar.8").bindKeyboard(KEY_8);
-	public KeyBinding keyHotBarSlot9 = new KeyBinding("key.hotbar.9").bindKeyboard(KEY_9);
+	public KeyBinding keyHotBarSlot1 = new KeyBinding("key.hotbar.1").setDefault(InputDevice.keyboard, KEY_1);
+	public KeyBinding keyHotBarSlot2 = new KeyBinding("key.hotbar.2").setDefault(InputDevice.keyboard, KEY_2);
+	public KeyBinding keyHotBarSlot3 = new KeyBinding("key.hotbar.3").setDefault(InputDevice.keyboard, KEY_3);
+	public KeyBinding keyHotBarSlot4 = new KeyBinding("key.hotbar.4").setDefault(InputDevice.keyboard, KEY_4);
+	public KeyBinding keyHotBarSlot5 = new KeyBinding("key.hotbar.5").setDefault(InputDevice.keyboard, KEY_5);
+	public KeyBinding keyHotBarSlot6 = new KeyBinding("key.hotbar.6").setDefault(InputDevice.keyboard, KEY_6);
+	public KeyBinding keyHotBarSlot7 = new KeyBinding("key.hotbar.7").setDefault(InputDevice.keyboard, KEY_7);
+	public KeyBinding keyHotBarSlot8 = new KeyBinding("key.hotbar.8").setDefault(InputDevice.keyboard, KEY_8);
+	public KeyBinding keyHotBarSlot9 = new KeyBinding("key.hotbar.9").setDefault(InputDevice.keyboard, KEY_9);
 
-	public KeyBinding keyLookLeft = new KeyBinding("key.look.left").bindKeyboard(KEY_LEFT);
-	public KeyBinding keyLookRight = new KeyBinding("key.look.right").bindKeyboard(KEY_RIGHT);
-	public KeyBinding keyLookUp = new KeyBinding("key.look.up").bindKeyboard(KEY_UP);
-	public KeyBinding keyLookDown = new KeyBinding("key.look.down").bindKeyboard(KEY_DOWN);
-	public KeyBinding keyCenterView = new KeyBinding("key.look.center").bindKeyboard(KEY_END);
-	public KeyBinding keyZoom = new KeyBinding("key.zoom").bindKeyboard(KEY_C);
-	public KeyBinding keyPlayerList = new KeyBinding("key.playerList").bindKeyboard(KEY_L);
-	public KeyBinding keyPhotoMode = new KeyBinding("key.photoMode").bindKeyboard(KEY_P);
-	public KeyBinding keyLockRotation = new KeyBinding("key.lockRotation").bindKeyboard(KEY_Z);
-	public KeyBinding keyScreenshot = new KeyBinding("key.screenshot").bindKeyboard(KEY_F2);
-	public KeyBinding keyCinematicCamera = new KeyBinding("key.cinematicCamera").bindKeyboard(KEY_F8);
-	public KeyBinding keySwitchPerspective = new KeyBinding("key.switchPerspective").bindKeyboard(KEY_F5);
-	public KeyBinding keyHideGui = new KeyBinding("key.immersiveMode").bindKeyboard(KEY_F1);
-	public KeyBinding keyAutoWalk = new KeyBinding("key.autoWalk").bindKeyboard(KEY_NONE);
-	public KeyBinding keySprint = new KeyBinding("key.sprint").bindKeyboard(KEY_NONE);
-	public KeyBinding keyToggleDebug = new KeyBinding("key.toggleDebug").bindKeyboard(KEY_F3);
-	public KeyBinding keyToggleOverlay = new KeyBinding("key.toggleOverlay").bindKeyboard(KEY_F4);
+	public KeyBinding keyLookLeft = new KeyBinding("key.look.left").setDefault(InputDevice.keyboard, KEY_LEFT);
+	public KeyBinding keyLookRight = new KeyBinding("key.look.right").setDefault(InputDevice.keyboard, KEY_RIGHT);
+	public KeyBinding keyLookUp = new KeyBinding("key.look.up").setDefault(InputDevice.keyboard, KEY_UP);
+	public KeyBinding keyLookDown = new KeyBinding("key.look.down").setDefault(InputDevice.keyboard, KEY_DOWN);
+	public KeyBinding keyCenterView = new KeyBinding("key.look.center").setDefault(InputDevice.keyboard, KEY_END);
+	public KeyBinding keyZoom = new KeyBinding("key.zoom").setDefault(InputDevice.keyboard, KEY_C);
+	public KeyBinding keyPlayerList = new KeyBinding("key.playerList").setDefault(InputDevice.keyboard, KEY_L);
+	public KeyBinding keyPhotoMode = new KeyBinding("key.photoMode").setDefault(InputDevice.keyboard, KEY_P);
+	public KeyBinding keyLockRotation = new KeyBinding("key.lockRotation").setDefault(InputDevice.keyboard, KEY_Z);
+	public KeyBinding keyScreenshot = new KeyBinding("key.screenshot").setDefault(InputDevice.keyboard, KEY_F2);
+	public KeyBinding keyCinematicCamera = new KeyBinding("key.cinematicCamera").setDefault(InputDevice.keyboard, KEY_F8);
+	public KeyBinding keySwitchPerspective = new KeyBinding("key.switchPerspective").setDefault(InputDevice.keyboard, KEY_F5);
+	public KeyBinding keyHideGui = new KeyBinding("key.immersiveMode").setDefault(InputDevice.keyboard, KEY_F1);
+	public KeyBinding keyAutoWalk = new KeyBinding("key.autoWalk");
+	public KeyBinding keySprint = new KeyBinding("key.sprint");
+	public KeyBinding keyToggleDebug = new KeyBinding("key.toggleDebug").setDefault(InputDevice.keyboard, KEY_F3);
+	public KeyBinding keyToggleOverlay = new KeyBinding("key.toggleOverlay").setDefault(InputDevice.keyboard, KEY_F4);
+	public KeyBinding keyToggleTextureAtlas = new KeyBinding("key.debug.textureAtlas");
 
 	public KeyBinding[] keys = ReflectUtils.getAllObjects(GameSettings.class, KeyBinding.class, this);
 
@@ -316,8 +317,7 @@ public class GameSettings {
 			}
 		}
 		if(option == customFpsLimit){
-			Option<Integer> limit = (Option<Integer>) option;
-			int value = limit.value;
+			int value = customFpsLimit.value;
 			int maxValue = 240;
 			if (enableVsync.value){
 				if(mc.gameWindow instanceof GameWindowLWJGL2){
@@ -325,10 +325,10 @@ public class GameSettings {
 				}
 			}
 			if(value > maxValue){
-				limit.set(maxValue);
+				customFpsLimit.set(maxValue);
 			}
 			if(value < 15){
-				limit.set(0);
+				customFpsLimit.set(0);
 				return trans.translateKey("options.customFpsLimit.unlimited");
 			}
 		}
@@ -442,11 +442,10 @@ public class GameSettings {
 			
 line:		for (String line = ""; (line = br.readLine()) != null;) {
 				try {
-					String[] as = line.split(":");
-
-					String key = as[0];
-					String value = as[1];
-
+					int i = line.indexOf(':');
+					String key = line.substring(0, i);
+					String value = line.substring(i + 1);
+					
 					if (key.equals("hudLayout")) {
 						HudComponents.INSTANCE.fromSettingsString(value);
 						continue line;
@@ -465,15 +464,15 @@ line:		for (String line = ""; (line = br.readLine()) != null;) {
                             continue line;
                         }
                     }
-				} catch (Exception exception1) {
+				} catch (Exception e) {
 					System.out.println("Skipping bad option: "+line);
 				}
 			}
 
 			br.close();
-		} catch (Exception exception) {
+		} catch (Exception e) {
 			System.out.println("Failed to load options");
-			exception.printStackTrace();
+			e.printStackTrace();
 		}
 	}
 	
diff --git a/src/main/java/net/minecraft/client/option/KeyBinding.java b/src/main/java/net/minecraft/client/option/KeyBinding.java
index debf10af3..8b6c8c33f 100644
--- a/src/main/java/net/minecraft/client/option/KeyBinding.java
+++ b/src/main/java/net/minecraft/client/option/KeyBinding.java
@@ -1,16 +1,36 @@
 package net.minecraft.client.option;
 
-import org.lwjgl.input.Keyboard;
+import java.util.HashMap;
+import java.util.Map;
 
+import net.minecraft.client.input.InputDevice;
 import net.minecraft.core.lang.I18n;
-import org.lwjgl.input.Mouse;
 
 public class KeyBinding {
-	private static String UNBOUND = "NONE";
-	private static final String[] MOUSE_BUTTON_NAMES = new String[] { "LEFT CLICK", "RIGHT CLICK", "MIDDLE CLICK" };
+	
+	private static Map<Character, InputDevice> charToInputDeviceMap = new HashMap<>();
+	private static Map<InputDevice, Character> inputDeviceToCharMap = new HashMap<>();
+	
+	public static void addInputDevice(char c, InputDevice inputDevice) {
+		if(charToInputDeviceMap.containsKey(c)) {
+			inputDeviceToCharMap.remove(charToInputDeviceMap.get(c));
+		}
+		if(inputDeviceToCharMap.containsKey(inputDevice)) {
+			charToInputDeviceMap.remove(inputDeviceToCharMap.get(inputDevice));
+		}
+		charToInputDeviceMap.put(c, inputDevice);
+		inputDeviceToCharMap.put(inputDevice, c);
+	}
+	
+	static {
+		addInputDevice('m', InputDevice.mouse);
+		addInputDevice('k', InputDevice.keyboard);
+	}
+	
 	private final String id;
-	private InputDevice inputDevice;
-	private int keyCode;
+	
+	private InputDevice inputDevice = null;
+	private int keyCode = -1;
 
 	private InputDevice defaultInputDevice = null;
 	private int defaultKeyCode = -1;
@@ -21,30 +41,27 @@ public class KeyBinding {
 		this.keyCode = -1;
 	}
 
-	public KeyBinding bindKeyboard(int keyCode) {
-		this.keyCode = keyCode;
-		this.inputDevice = InputDevice.KEYBOARD;
-
-		if (this.defaultInputDevice == null) {
-			this.defaultInputDevice = InputDevice.KEYBOARD;
-			this.defaultKeyCode = keyCode;
+	public KeyBinding setDefault(InputDevice device, int keyCode) {
+		if(device != null && !device.isKeyCodeValid(keyCode)) {
+			throw new RuntimeException("Key code " + keyCode + " is not valid for input device " + device);
 		}
-
-		return this;
+		
+		this.defaultInputDevice = device;
+		this.defaultKeyCode = keyCode;
+		
+		return bind(device, keyCode);
 	}
-
-	public KeyBinding bindMouse(int keyCode) {
-		this.keyCode = keyCode;
-		this.inputDevice = InputDevice.MOUSE;
-
-		if (this.defaultInputDevice == null) {
-			this.defaultInputDevice = InputDevice.MOUSE;
-			this.defaultKeyCode = keyCode;
+	
+	public KeyBinding bind(InputDevice device, int keyCode) {
+		if(device.isKeyCodeValid(keyCode)) {
+			this.keyCode = keyCode;
+			this.inputDevice = device;	
+		}else {
+			unbind();
 		}
-
 		return this;
 	}
-
+	
 	public KeyBinding unbind() {
 		this.keyCode = -1;
 		this.inputDevice = null;
@@ -74,96 +91,87 @@ public class KeyBinding {
 	}
 
 	public boolean isPressed() {
-		if (!isBound()) return false;
-		if(keyCode >= 0) {
-			switch (inputDevice) {
-				case KEYBOARD:
-					return Keyboard.isKeyDown(keyCode);
-				case MOUSE:
-					return Mouse.isButtonDown(keyCode);
-			}
+		if(inputDevice != null) {
+			return inputDevice.isPressed(keyCode);
 		}
 		return false;
 	}
 
 	public boolean isPressEvent(InputDevice eventInputDevice) {
-		if (!isBound() || eventInputDevice != inputDevice) return false;
-		switch (inputDevice) {
-			case KEYBOARD:
-				return Keyboard.getEventKey() == keyCode && Keyboard.getEventKeyState();
-			case MOUSE:
-				return Mouse.getEventButton() == keyCode && Mouse.getEventButtonState();
+		if(inputDevice == eventInputDevice) {
+			return inputDevice.isPressEvent(keyCode);
 		}
 		return false;
 	}
 
 	public boolean isReleaseEvent(InputDevice eventInputDevice) {
-		if (!isBound() || eventInputDevice != inputDevice) return false;
-		switch (inputDevice) {
-			case KEYBOARD:
-				return Keyboard.getEventKey() == keyCode && !Keyboard.getEventKeyState();
-			case MOUSE:
-				return Mouse.getEventButton() == keyCode && !Mouse.getEventButtonState();
+		if(inputDevice == eventInputDevice) {
+			return inputDevice.isReleaseEvent(keyCode);
 		}
 		return false;
 	}
 
 	public void fromOptionsString(String value) {
-		if (value.equals(UNBOUND)) {
-			this.unbind();
+		if(value.length() == 0) {
+			unbind();
 			return;
 		}
-
-		if (value.startsWith("m")) {
-			bindMouse(Integer.parseInt(value.substring(1)));
-		} else if (value.startsWith("k")) {
-			bindKeyboard(Integer.parseInt(value.substring(1)));
-		} else {
-			bindKeyboard(Integer.parseInt(value));
+		
+		char c = value.charAt(0);
+		
+		InputDevice inputDevice;
+		int code;
+		if(c >= '0' && c <= '9') {
+			inputDevice = InputDevice.keyboard;
+			code = Integer.parseInt(value);
+		}else {
+			inputDevice = charToInputDeviceMap.get(c);
+			code = Integer.parseInt(value.substring(1));
+		}
+		
+		if(inputDevice == null) {
+			unbind();
+			return;
 		}
+		
+		bind(inputDevice, code);
 	}
 
 	public String toOptionsString() {
-		if(!isBound()) {
-			return UNBOUND;
-		}
-		switch (inputDevice) {
-			case KEYBOARD:
-				return "k" + keyCode;
-			case MOUSE:
-				return "m" + keyCode;
+		Character c = inputDeviceToCharMap.get(inputDevice);
+		if(c != null) {
+			return String.valueOf(c) + keyCode;
 		}
 		return "";
 	}
 	
 	public boolean isKeyboardKey(int key) {
-		if(this.keyCode <= 0 || this.inputDevice != InputDevice.KEYBOARD) return false;
-		return this.keyCode == key;
+		if(inputDevice == InputDevice.keyboard) {
+			return keyCode == key;
+		}
+		return false;
 	}
 
 	public boolean isMouseButton(int button) {
-		if(this.keyCode < 0 || this.inputDevice != InputDevice.MOUSE) return false;
-		return this.keyCode == button;
+		if(inputDevice == InputDevice.mouse) {
+			return keyCode == button;
+		}
+		return false;
 	}
 	
 	public boolean isBound() {
-		return !(inputDevice == null || ((inputDevice == InputDevice.KEYBOARD && keyCode < 0) || (inputDevice == InputDevice.MOUSE && keyCode < 0)));
+		return inputDevice != null;
 	}
 	
 	public String getKeyName() {
-		if(!isBound()) {
+		if(inputDevice == null) {
 			return I18n.getInstance().translateKey("key.disabled");
 		}
-		switch (inputDevice) {
-			case KEYBOARD:
-				return Keyboard.getKeyName(keyCode);
-			case MOUSE:
-				if (keyCode < MOUSE_BUTTON_NAMES.length) {
-					return MOUSE_BUTTON_NAMES[keyCode];
-				} else {
-					return "MOUSE " + (keyCode + 1);
-				}
+		
+		String keyName = inputDevice.getKeyName(keyCode);
+		if(keyName == null) {
+			keyName = String.valueOf(keyCode);
 		}
-		return "";
+		return keyName;
 	}
 }
diff --git a/src/main/java/net/minecraft/client/player/controller/PlayerController.java b/src/main/java/net/minecraft/client/player/controller/PlayerController.java
index d03fcf2b3..1988619e3 100644
--- a/src/main/java/net/minecraft/client/player/controller/PlayerController.java
+++ b/src/main/java/net/minecraft/client/player/controller/PlayerController.java
@@ -265,8 +265,8 @@ public abstract class PlayerController {
 		return new EntityPlayerSP(mc, world, mc.session, world.dimension.id);
 	}
 
-	public void interact(EntityPlayer entityplayer, Entity entity) {
-		entityplayer.useCurrentItemOnEntity(entity);
+	public boolean interact(EntityPlayer entityplayer, Entity entity) {
+		return entityplayer.useCurrentItemOnEntity(entity);
 	}
 
 	public void attack(EntityPlayer entityplayer, Entity entity) {
diff --git a/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java b/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
index eeff5f7c6..3d6540857 100644
--- a/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
+++ b/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
@@ -92,10 +92,10 @@ public class PlayerControllerMP extends PlayerController {
 	}
 
 	@Override
-	public void interact(EntityPlayer entityplayer, Entity entity) {
+	public boolean interact(EntityPlayer entityplayer, Entity entity) {
 		syncCurrentPlayItem();
 		netHandler.addToSendQueue(new Packet7UseEntity(entityplayer.id, entity.id, 0));
-		entityplayer.useCurrentItemOnEntity(entity);
+		return entityplayer.useCurrentItemOnEntity(entity);
 	}
 
 	@Override
diff --git a/src/main/java/net/minecraft/client/render/ChunkRenderer.java b/src/main/java/net/minecraft/client/render/ChunkRenderer.java
index 6fb1c0f7a..10fc0cc9a 100644
--- a/src/main/java/net/minecraft/client/render/ChunkRenderer.java
+++ b/src/main/java/net/minecraft/client/render/ChunkRenderer.java
@@ -19,6 +19,7 @@ import org.lwjgl.opengl.GL11;
 import java.util.ArrayList;
 import java.util.HashSet;
 import java.util.List;
+import java.util.Set;
 
 public class ChunkRenderer
 {
@@ -74,57 +75,48 @@ public class ChunkRenderer
 
     public void updateRenderer()
     {
-        if(!needsUpdate)
-        {
-            return;
-        }
+        if(!needsUpdate) { return; }
         chunksUpdated++;
-        int minX = posX;
-        int minY = posY;
-        int minZ = posZ;
-        int maxX = posX + sizeWidth;
-        int maxY = posY + sizeHeight;
-        int maxZ = posZ + sizeDepth;
-        for(int i = 0; i < MAX_RENDER_PASSES; i++)
-        {
-            skipRenderPass[i] = true;
-        }
+        final int minX = posX;
+        final int minY = posY;
+        final int minZ = posZ;
+        final int maxX = posX + sizeWidth;
+        final int maxY = posY + sizeHeight;
+        final int maxZ = posZ + sizeDepth;
+        for(int i = 0; i < MAX_RENDER_PASSES; i++) { skipRenderPass[i] = true; }
 
         Chunk.isLit = false;
-        HashSet<TileEntity> lastSpecialTileEntities = new HashSet<>(specialTileEntities);
+        final Set<TileEntity> lastSpecialTileEntities = new HashSet<>(specialTileEntities);
         specialTileEntities.clear();
-        int cacheRadius = 1;
-        ChunkCache chunkcache = new ChunkCache(worldObj, minX - cacheRadius, minY - cacheRadius, minZ - cacheRadius, maxX + cacheRadius, maxY + cacheRadius, maxZ + cacheRadius);
-        RenderBlocks renderblocks = new RenderBlocks(chunkcache);
+        final int cacheRadius = 1;
+        final ChunkCache chunkcache = new ChunkCache(worldObj, minX - cacheRadius, minY - cacheRadius, minZ - cacheRadius, maxX + cacheRadius, maxY + cacheRadius, maxZ + cacheRadius);
+        final RenderBlocks renderblocks = new RenderBlocks(chunkcache);
         BlockModel.setRenderBlocks(renderblocks);
         int renderPass = 0;
         do
         {
-            if(renderPass >= MAX_RENDER_PASSES)
-            {
-                break;
-            }
+            if(renderPass >= MAX_RENDER_PASSES) { break; }
+
             boolean needsMoreRenderPasses = false;
             boolean hasRenderedBlock = false;
             boolean hasStartedDrawing = false;
+
             for(int y = minY; y < maxY; y++)
             {
                 for(int z = minZ; z < maxZ; z++)
                 {
                     for(int x = minX; x < maxX; x++)
                     {
-                        int blockId = chunkcache.getBlockId(x, y, z);
-                        if(blockId <= 0)
-                        {
+                        final int blockId = chunkcache.getBlockId(x, y, z);
+                        if(blockId <= 0) {
                             continue;
                         }
-                        if(!hasStartedDrawing)
-                        {
+                        if(!hasStartedDrawing) {
                             hasStartedDrawing = true;
                             GL11.glNewList(glRenderList + renderPass, GL11.GL_COMPILE);
                             GL11.glPushMatrix();
                             setupGLTranslation();
-                            float scale = 1.000001F;
+                            final float scale = 1.000001F;
                             GL11.glTranslatef((float)(-sizeDepth) / 2.0F, (float)(-sizeHeight) / 2.0F, (float)(-sizeDepth) / 2.0F);
                             GL11.glScalef(scale, scale, scale);
                             GL11.glTranslatef((float)sizeDepth / 2.0F, (float)sizeHeight / 2.0F, (float)sizeDepth / 2.0F);
@@ -136,58 +128,47 @@ public class ChunkRenderer
                             	tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 15));
                             }
                         }
-                        if(renderPass == 0 && Block.isEntityTile[blockId])
-                        {
-                            TileEntity tileentity = chunkcache.getBlockTileEntity(x, y, z);
-                            if(TileEntityRenderDispatcher.instance.hasRenderer(tileentity))
-                            {
+                        if(renderPass == 0 && Block.isEntityTile[blockId]) {
+                            final TileEntity tileentity = chunkcache.getBlockTileEntity(x, y, z);
+                            if(TileEntityRenderDispatcher.instance.hasRenderer(tileentity)) {
                                 specialTileEntities.add(tileentity);
                             }
                         }
-                        Block block = Block.blocksList[blockId];
-                        int blockRenderPass = block.getRenderBlockPass();
-                        if(blockRenderPass != renderPass)
-                        {
+                        final Block block = Block.blocksList[blockId];
+                        final int blockRenderPass = block.getRenderBlockPass();
+                        if(blockRenderPass != renderPass) {
                             needsMoreRenderPasses = true;
                         }
-                        else
-                        {
+                        else {
                         	if(LightmapHelper.isLightmapEnabled()) {
                         		// Can probably be removed once all block models support the lightmap
                         		tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 0));	
                         	}
                             
-                            BlockModel<Block> model = BlockModelDispatcher.getInstance().getDispatch(block);
+                            final BlockModel<Block> model = BlockModelDispatcher.getInstance().getDispatch(block);
                             hasRenderedBlock |= model.render(tessellator, x, y, z);
-                            if (model.hasOverbright())
-                            {
+                            if (model.hasOverbright()) {
                             	renderblocks.overbright = true;
                                 hasRenderedBlock |= model.render(tessellator, x, y, z);
                                 renderblocks.overbright = false;
                             }
                         }
                     }
-
                 }
-
             }
-            if(hasStartedDrawing)
-            {
+            if(hasStartedDrawing) {
                 tessellator.draw();
                 GL11.glPopMatrix();
                 GL11.glEndList();
                 tessellator.setTranslation(0.0D, 0.0D, 0.0D);
-            } else
-            {
+            } else {
                 hasRenderedBlock = false;
             }
             
-            if(hasRenderedBlock)
-            {
+            if(hasRenderedBlock) {
                 skipRenderPass[renderPass] = false;
             }            
-            if(!needsMoreRenderPasses)
-            {
+            if(!needsMoreRenderPasses) {
                 break;
             }
             
diff --git a/src/main/java/net/minecraft/client/render/EffectRenderer.java b/src/main/java/net/minecraft/client/render/EffectRenderer.java
index 23d1ef3cb..527d5d8b7 100644
--- a/src/main/java/net/minecraft/client/render/EffectRenderer.java
+++ b/src/main/java/net/minecraft/client/render/EffectRenderer.java
@@ -135,27 +135,24 @@ public class EffectRenderer
 
     }
 
-    public void addBlockDestroyEffects(int i, int j, int k, int l, int i1)
+    public void addBlockDestroyEffects(int x, int y, int z, int blockId, int i1)
     {
-        if(l == 0)
-        {
-            return;
-        }
-        Block block = Block.blocksList[l];
-        int j1 = 4;
+        Block block = Block.blocksList[blockId];
+        if (block == null) return;
+        int amount = 4;
         if(block == Block.fire)
             return;
-        for(int k1 = 0; k1 < j1; k1++)
+        for(int _x = 0; _x < amount; _x++)
         {
-            for(int l1 = 0; l1 < j1; l1++)
+            for(int _y = 0; _y < amount; _y++)
             {
-                for(int i2 = 0; i2 < j1; i2++)
+                for(int _z = 0; _z < amount; _z++)
                 {
-                    double d = (double)i + ((double)k1 + 0.5D) / (double)j1;
-                    double d1 = (double)j + ((double)l1 + 0.5D) / (double)j1;
-                    double d2 = (double)k + ((double)i2 + 0.5D) / (double)j1;
-                    int j2 = rand.nextInt(6);
-                    addEffect((new EntityDiggingFX(worldObj, d, d1, d2, d - (double)i - 0.5D, d1 - (double)j - 0.5D, d2 - (double)k - 0.5D, block, j2, i1)).setParticleColor(i, j, k));
+                    double pX = (double)x + ((double)_x + 0.5D) / (double)amount;
+                    double pY = (double)y + ((double)_y + 0.5D) / (double)amount;
+                    double pZ = (double)z + ((double)_z + 0.5D) / (double)amount;
+                    int side = rand.nextInt(6);
+                    addEffect((new EntityDiggingFX(worldObj, pX, pY, pZ, pX - (double)x - 0.5D, pY - (double)y - 0.5D, pZ - (double)z - 0.5D, block, side, i1)).setParticleColor(x, y, z));
                 }
 
             }
